#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 DarkGray
#property indicator_color2 DarkGray
#property indicator_color3 Red
#property indicator_width1 2
#property indicator_width2 2

extern int FastEMA   = 12;
extern int SlowEMA   = 26;
extern int SignalEMA =  9;

//
//
//

double macd[];
double signal[];
double histo[];

int init()
{
   SetIndexBuffer(0,histo); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,macd);
   SetIndexBuffer(2,signal);
   return(0);
}

int start()
{
   int i,count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   for(i = limit; i >= 0; i--) macd[i] = iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);
   for(i = limit; i >= 0; i--)
   {
      signal[i] = iMAOnArray(macd,0,SignalEMA,0,MODE_EMA,i);
      histo[i]  = macd[i]-signal[i];
   }      
   return(0);
} 